/*
 * gsampler-channel-manager.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_CHANNEL_MANAGER_H_
#define _GSAMPLER_CHANNEL_MANAGER_H_

#include <gtk/gtk.h>

#include "gsampler-keyboard.h"

G_BEGIN_DECLS

#define GSAMPLER_TYPE_CHANNEL_MANAGER (gsampler_channel_manager_get_type ())
#define GSAMPLER_CHANNEL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_CHANNEL_MANAGER, GsamplerChannelManager))
#define GSAMPLER_CHANNEL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_CHANNEL_MANAGER, GsamplerChannelManagerClass))
#define GSAMPLER_IS_CHANNEL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_CHANNEL_MANAGER))
#define GSAMPLER_IS_CHANNEL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_CHANNEL_MANAGER))
#define GSAMPLER_CHANNEL_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_CHANNEL_MANAGER, GsamplerChannelManagerClass))
#define GSAMPLER_CHANNEL_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_CHANNEL_MANAGER, GsamplerChannelManagerPrivate))

typedef struct _GsamplerChannelManager GsamplerChannelManager;
typedef struct _GsamplerChannelManagerClass GsamplerChannelManagerClass;
typedef struct _GsamplerChannelManagerPrivate GsamplerChannelManagerPrivate;

struct _GsamplerChannelManager {
	GtkBox parent_instance;
	GsamplerChannelManagerPrivate * priv;
};

struct _GsamplerChannelManagerClass {
	GtkBoxClass parent_class;
};

struct _GsamplerChannelManagerPrivate {
	GtkBox* channel_box;
};

GType 					gsampler_channel_manager_get_type (void) G_GNUC_CONST;
GsamplerChannelManager* gsampler_channel_manager_new (void);
GsamplerChannelManager* gsampler_channel_manager_get_instance (void);

void 					gsampler_channel_manager_active (GsamplerChannelManager* self);
void 					gsampler_channel_manager_inactive (GsamplerChannelManager* self);
void 					gsampler_channel_manager_on_note_on (GsamplerKeyboard* sender, gint chan,
					                                         gint pitch, gint vel, gpointer data);
void 					gsampler_channel_manager_on_note_off (GsamplerKeyboard* sender, gint chan,
					                                          gint pitch, gint vel, gpointer data);

GSList* 				gsampler_channel_manager_get_channels (void);
gint 					gsampler_channel_manager_create_channel (GsamplerChannelManager* self);
gboolean 				gsampler_channel_manager_update_channel (GsamplerChannelManager* self, 
				                                                 gint id, const gchar* engine, 
				                                                 const gchar* file, gint* inst_id);

G_END_DECLS

#endif /* _GSAMPLER_CHANNEL_MANAGER_H_ */
